<?
/*
	Author		: Frederic Bonnaud, Charles Cordier
	Copyright	: 2001 Frederic Bonnaud, Charles Cordier
	EMail			: frederic.bonnaud@laposte.net, charles.cordier@laposte.net
	License		: GPL (see ../GPL)
	Warranty		: NONE, absolutly none
	Garanties	: Aucune, absolument aucune !
*/
	/***********************************************************
	* Intersections *******************************************
	***********************************************************/
	function clip_droite(& $ax, & $ay, & $bx, & $by) { //clippe $a et $b dans la fenetre ecran
		$dx=$bx-$ax ;
		$dy= $by-$ay ;
		if (abs($dy)>EPSILON) {
			if (
					(($x1 = $bx-$by*$dx/$dy)>=0) AND
					($x1<=LARG)
				 ) {
				$result[] = array($x1,0) ;
			}
			if (
					(($x2 = $bx+(HAUT-$by)*$dx/$dy)>=0) AND
					($x2<=LARG)
				 ) {
				$result[] = array($x2,HAUT) ;
			}
		}
		if (abs($dx)>EPSILON) {
			if (
					(count($result)<2) AND
					(
						(
							(($y1 = $by-$bx*$dy/$dx)>EPSILON) AND
							($y1<HAUT-EPSILON)
						) OR
						((abs($y1)<EPSILON) AND (abs($x1)>EPSILON)) OR
						((abs($y1-HAUT)<EPSILON) AND (abs($x2)>EPSILON))
					)
				 ) {
				$result[] = array(0, $y1) ;
			}
			if (
					(count($result)<2) AND
					(
						(
							(($y2 = $by+(LARG-$bx)*$dy/$dx)>EPSILON) AND
							($y2<HAUT-EPSILON)
						) OR
						((abs($y2)<EPSILON) AND (abs($x1-LARG)>EPSILON)) OR
						((abs($y2-HAUT)<EPSILON) AND (abs($x2-LARG)>EPSILON))
					)
				 ) {
				$result[] = array(LARG, $y2) ;
			}
		}
		list($ax,$ay)=$result[0] ;
		list($bx,$by)=$result[1] ;
		return (count($result)==2) ;
	}

	function intersection_cc($xc1,$yc1,$r1,$xc2,$yc2,$r2,&$x1,&$y1,&$x2,&$y2) { // intersection cercle/cercle
		$norme = distance($xc1,$yc1,$xc2,$yc2) ;
		if ($norme > EPSILON) {
			$a = $r1/$norme ;
			$b = $r2/$norme ;
			$aa = $a*$a ;
			$bb = $b*$b ;
			$xx = ($aa-$bb+1)/2 ;
			$rr = $aa-$xx*$xx ;
			if ($rr+EPSILON>0) {
				$yy = sqrt(max(0,$rr)) ;
				$dx = $xc2-$xc1 ;
				$dy = $yc2-$yc1 ;
				$x1 = $xx*$dx-$yy*$dy+$xc1 ;
				$y1 = $xx*$dy+$yy*$dx+$yc1 ;
				$x2 = $xx*$dx+$yy*$dy+$xc1 ;
				$y2 = $xx*$dy-$yy*$dx+$yc1 ;
				return 1 ;
			}
		}
		return $x1 = $x2 = $y1 = $y2 = 0 ;
	}

	function intersection_dc($ax,$ay,$bx,$by,$cx,$cy,$r,&$x1,&$y1,&$x2,&$y2) { // intersection droite/cercle
		// cas intersection droite/cercle

		// on rsoud : CH.AB = 0 et H appartient  (AB) (ie: det(AB,AH) = 0)
		// pour trouver les coordonnes de la projection de C sur (AB)

		$xab = $bx - $ax ;
		$yab = $by - $ay ;

		$ab2 = $xab*$xab+$yab*$yab ;

		if ($ab2 > EPSILON) {

			// les formules de cramers dans ce cas particuliers deviennent :
			$l1 = -$cx * $xab - $cy * $yab ;
			$l2 = -$ay * $xab + $ax * $yab ;

			$xh =  -determinant ($l1, $l2, $yab, $xab) / $ab2 ;

			$yh =  -determinant ($xab, -$yab, $l1, $l2) / $ab2 ;

			$CH = distance($xh,$yh,$cx,$cy) ;

			if ($CH<($r+EPSILON)) { // H est-il dans le disque ?
				$MH = sqrt(max(0,$r*$r-$CH*$CH)) ;
				$ab = sqrt($ab2) ;

				$dx = ($ax-$bx)/$ab*$MH ;
				$dy = ($ay-$by)/$ab*$MH ;

				$x1 = $xh + $dx ;
				$y1 = $yh + $dy ;
				// en gnral, il y a deux points d'intersection...
				$x2 = $xh - $dx ;
				$y2 = $yh - $dy ;

				return 1 ;
			}
		}
		return $x1 = $x2 = $y1 = $y2 = 0 ;
	}

	function intersection_dd($a1x,$a1y,$b1x,$b1y,$a2x,$a2y,$b2x,$b2y,&$x,&$y) { // intersection droite/droite
		// recherche des quations cartsiennes des deux droites...
		$b1 = $b1x - $a1x ;
		$b2 = $b2x - $a2x ;
		$a1 = $a1y - $b1y ;
		$a2 = $a2y - $b2y ;
		$c1 = - $a1y * $b1 - $a1x * $a1 ;
		$c2 = - $a2y * $b2 - $a2x * $a2 ;
		// utilisation des formules de cramers
		$det=determinant($a1,$a2,$b1,$b2) ;
		if (abs($det)>EPSILON) {
			$x = -determinant($c1,$c2,$b1,$b2)/$det ;
			$y = -determinant($a1,$a2,$c1,$c2)/$det ;
			return 1 ;
		} else { // les deux droites sont parellles
			return $x = $y = 0 ;
		}
	}
?>