<?
 /*
	Author		: Frederic Bonnaud, Charles Cordier
	Copyright	: 2001 Frederic Bonnaud, Charles Cordier
	EMail			: frederic.bonnaud@laposte.net, charles.cordier@laposte.net
	License		: GPL (see ../GPL)
	Warranty		: NONE, absolutly none
	Garanties	: Aucune, absolument aucune !
*/

$EXPORTED_FORMATS =array(
	'html'=>array("desc"=>msg_desc_html,"note"=>msg_note_html,"mime"=>"text/html","file"=>"exo.html"),
	'tex'=>array("desc"=>msg_desc_tex,"note"=>msg_note_tex,"mime"=>"text/x-tex","file"=>"exo.tex"),
	'xml'=>array("desc"=>msg_desc_xml,"note"=>msg_note_xml,"mime"=>"text/x-xml","file"=>"content.xml")
) ; //  modifier si l'on ajoute un export

function output($func,$text,$export) {
	global $EXPORTED_FORMATS ;
	if (!$EXPORTED_FORMATS[$export]) {
		$export = "html" ; // export par dfaut : html !
	}
	$func = "output_".$func."_".$export ;
	if (function_exists($func)) {
		return $func($text) ;
	} else {
		return $text ;
	}
}

// le filtre html :
function output_header_html($text) {
	return "<HTML>
<HEAD>
	<TITLE>$text</TITLE>
</HEAD>
<BODY>
" ;
}

function output_footer_html($text) {
	return "</BODY>
</HTML>" ;
}

function output_title_html($text) {
	return "<H1>$text</H1>" ;
}

function output_start_exo_table_html($text) {
	return "<TABLE ".ATTR_TABLE_EXO.">\n" ;
}

function output_end_exo_table_html($text) {
	return "</TABLE>\n" ;
}

function output_start_exo_row_html($text) {
	return "<TR>" ;
}

function output_end_exo_row_html($text) {
	return "</TR>" ;
}

function output_start_exo_col_html($text) {
	return "<TD ".ATTR_COLONNE_EXO.$text.">" ;
}

function output_end_exo_col_html($text) {
	return "</TD>" ;
}

function output_title_section_html($text) {
	return "<H3>$text</H3>\n" ;
}

function output_start_unsorted_list_html($text) {
	return "<UL TYPE=NONE>\n" ;
}

function output_start_sorted_list_html($text) {
	return "<OL TYPE=1>\n" ;
}

function output_end_unsorted_list_html($text) {
	return "</UL>\n" ;
}

function output_end_sorted_list_html($text) {
	return "</OL>\n" ;
}

function output_math_html($text) {
	return "<I>$text</I>" ;
}

function output_phpgeo_html($text) {
	return DEBUT_TAG_PHPGEO."$text".FIN_TAG_PHPGEO ;
}

function output_cadre_html($text) {
	return $text[0]."<TABLE WIDTH=95% BORDER=1><TR>\n<TD>".nls($text[1])."</TD></TR>\n</TABLE>\n"  ;
}

function output_list_item_html($text) {
	return "<LI>$text</LI>\n" ;
}

function output_italique_html($text) {
	return "<I>$text</I>" ;
}

function output_cleanup_html($text) {
	return $text ;
}

// export tex
function output_translate_tex($text) {
	return preg_replace(
		array(
			'//',
			'//',
			'//',
			'//',
			'//'
		),
		array(
			'\\\'e',
			'\\`e',
			'\\`a',
			'\\^o',
			'\\^a'
		),
		$text) ;
}

function output_header_tex($text) {
	return '\documentclass{article}

\evensidemargin=0pt
\oddsidemargin=0pt
\topmargin=-30mm
\textwidth=150mm \textheight=270mm % normal A4, 1 cm margin
\parindent=0mm

\def\phpgeotitle#1{{\bf\Large #1}\\\\[\baselineskip]}
\def\phpgeosection#1{{\bf\large #1}}
\def\phpgeomesure#1{\ {\rm #1}}

\begin{document}
\pagestyle{empty}

' ;
}

function output_footer_tex($text) {
	return "\eject\n\end{document}" ;
}

function output_title_tex($text) {
	return "\\phpgeotitle{".output_translate_tex($text)."}\n" ;
}
function output_start_exo_table_tex($text) {
	return "" ;
}

function output_end_exo_table_tex($text) {
	return "" ;
}

function output_start_exo_row_tex($text) {
	return "" ;
}

function output_end_exo_row_tex($text) {
	return "" ;
}

function output_start_exo_col_tex($text) {
	return "" ;
}

function output_end_exo_col_tex($text) {
	return "" ;
}

function output_title_section_tex($text) {
	return "\\phpgeosection{".output_translate_tex($text)."}\n" ;
}

function output_start_unsorted_list_tex($text) {
	return "\\begin{itemize}\n" ;
}

function output_start_sorted_list_tex($text) {
	return "\\begin{enumerate}\n" ;
}

function output_end_unsorted_list_tex($text) {
	return "\\end{itemize}\n" ;
}

function output_end_sorted_list_tex($text) {
	return "\\end{enumerate}\n" ;
}

function output_math_tex($text) {
	$text = preg_replace("~".SPLIT_MESURE."~","$1\\ \\phpgeomesure\{$2}",$text) ;
	return "\$$text\$" ;
}

function output_phpgeo_tex($text) {
	return "\\begin{quote}\\begin{verbatim}$text\\end{verbatim}\\end{quote}\n" ;
}

function output_cadre_tex($text) {
	return output_translate_tex($text[0])."\\"."\\"."\\vbox{\\hrule\\hbox{\\vrule height ".($text[1]*5)."mm\\vbox{\\hskip ".($text[1]*5)."mm}\\vrule}\\hrule}\n" ;
}

function output_list_item_tex($text) {
	return "\\item{".output_translate_tex($text)."}\n" ;
}

function output_italique_tex($text) {
	return "{\\it ".output_translate_tex($text)."}" ;
}

function output_cleanup_tex($text) {
	return $text ;
}


// export xml/openoffice
function output_translate_xml($text) {
// UTF-8-ification ! (basique...)
	return preg_replace(
		array(
			'//',
			'//',
			'//',
			'//',
			'//'
		),
		array(
			'é',
			'è',
			'à',
			'ô',
			'ë'
		),
		$text) ;
}

function output_header_xml($text) {
	return '<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE office:document-content PUBLIC "-//OpenOffice.org//DTD OfficeDocument 1.0//EN" "office.dtd">
<office:document-content xmlns:office="http://openoffice.org/2000/office" xmlns:style="http://openoffice.org/2000/style" xmlns:text="http://openoffice.org/2000/text" xmlns:table="http://openoffice.org/2000/table" xmlns:draw="http://openoffice.org/2000/drawing" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:xlink="http://www.w3.org/1999/xlink" xmlns:number="http://openoffice.org/2000/datastyle" xmlns:svg="http://www.w3.org/2000/svg" xmlns:chart="http://openoffice.org/2000/chart" xmlns:dr3d="http://openoffice.org/2000/dr3d" xmlns:math="http://www.w3.org/1998/Math/MathML" xmlns:form="http://openoffice.org/2000/form" xmlns:script="http://openoffice.org/2000/script" office:class="text" office:version="1.0">
 <office:script/>
 <office:font-decls>
  <style:font-decl style:name="StarSymbol" fo:font-family="StarSymbol" style:font-charset="x-symbol"/>
  <style:font-decl style:name="Helvetica" fo:font-family="Helvetica" style:font-style-name="Regular" style:font-family-generic="swiss" style:font-pitch="variable"/>
   <style:font-decl style:name="Times New Roman" fo:font-family="&apos;Times New Roman&apos;" style:font-pitch="variable"/>
  <style:font-decl style:name="Courier New" fo:font-family="&apos;Courier New&apos;" style:font-pitch="fixed"/>
  <style:font-decl style:name="Arial" fo:font-family="Arial" style:font-family-generic="swiss" style:font-pitch="variable"/>
 </office:font-decls>
 <office:automatic-styles>
  <style:style style:name="titre" style:family="paragraph" style:parent-style-name="Standard">
   <style:properties style:font-name="Times New Roman" fo:font-size="32pt" style:text-underline="single" style:text-underline-color="font-color" fo:font-weight="bold"/>
  </style:style>
  <style:style style:name="soustitre" style:family="paragraph" style:parent-style-name="Standard">
   <style:properties style:font-name="Times New Roman" style:text-underline="single" style:text-underline-color="font-color" fo:margin-top="0.5cm" fo:font-size="15pt" fo:font-weight="bold"/>
  </style:style>
  <style:style style:name="normal" style:family="paragraph" style:parent-style-name="Standard">
   <style:properties style:font-name="Arial" fo:font-size="12pt"/>
  </style:style>
  <style:style style:name="quote" style:family="paragraph" style:parent-style-name="Standard">
   <style:properties fo:margin-left="1.5cm" fo:margin-right="0cm" style:font-name="Courier New" fo:font-size="12pt" fo:font-style="normal" style:text-underline="none" fo:font-weight="normal" fo:text-align="start" style:justify-single-word="false" fo:text-indent="0cm" style:auto-text-indent="false"/>
  </style:style>
  <style:style style:name="italic" style:family="text">
   <style:properties fo:font-style="italic" fo:font-weight="normal"/>
  </style:style>
  <text:list-style style:name="sorted">
   <text:list-level-style-number text:level="1" text:style-name="Numbering Symbols" style:num-suffix="." style:num-format="1">
    <style:properties text:min-label-width="0.499cm"/>
   </text:list-level-style-number>
  </text:list-style>
  <text:list-style style:name="unsorted">
   <text:list-level-style-bullet text:level="1" text:style-name="Bullet Symbols" style:num-suffix="." text:bullet-char=" ">
    <style:properties text:min-label-width="0.499cm" style:font-name="StarSymbol"/>
   </text:list-level-style-bullet>
  </text:list-style>
  <style:style style:name="cadre" style:family="graphics">
   <style:properties draw:fill="none" draw:textarea-horizontal-align="center" draw:textarea-vertical-align="middle" style:run-through="foreground" style:wrap="none" style:wrap-contour-mode="full" style:number-wrapped-paragraphs="1"/>
  </style:style>
 </office:automatic-styles>
 <office:body>
  <text:sequence-decls>
   <text:sequence-decl text:display-outline-level="0" text:name="Illustration"/>
   <text:sequence-decl text:display-outline-level="0" text:name="Table"/>
   <text:sequence-decl text:display-outline-level="0" text:name="Text"/>
   <text:sequence-decl text:display-outline-level="0" text:name="Drawing"/>
  </text:sequence-decls>
' ;
}

function output_footer_xml($text) {
	return '
</office:body>
</office:document-content>' ;
}

function output_title_xml($text) {
	return '<text:p text:style-name="titre">'.output_translate_xml($text)."</text:p>\n" ;
}
function output_start_exo_table_xml($text) {
	return '' ;
}

function output_end_exo_table_xml($text) {
	return '' ;
}

function output_start_exo_row_xml($text) {
	return '' ;
}

function output_end_exo_row_xml($text) {
	return '' ;
}

function output_start_exo_col_xml($text) {
	return '' ;
}

function output_end_exo_col_xml($text) {
	return '' ;
}

function output_title_section_xml($text) {
	return '<text:p text:style-name="soustitre">'.output_translate_xml($text)."</text:p>\n" ;
}

function output_start_unsorted_list_xml($text) {
	return ' <text:unordered-list text:style-name="unsorted">
' ;
}

function output_start_sorted_list_xml($text) {
	return '<text:ordered-list text:style-name="sorted">
' ;
}

function output_end_unsorted_list_xml($text) {
	return "</text:unordered-list>\n" ;
}

function output_end_sorted_list_xml($text) {
	return "</text:ordered-list>\n" ;
}

function output_math_xml($text) {
	return '<text:span text:style-name="italic">'.$text.'</text:span>' ;
}

function output_phpgeo_xml($text) {
	$text = preg_replace("/\n/", '</text:p>
<text:p text:style-name="quote">', $text) ;
	return '</text:p>
<text:p text:style-name="quote">'.$text.'</text:p>
<text:p text:style-name="normal">
' ;
}

function output_cadre_xml($text) {
	return output_translate_xml($text[0]).'</text:p>
<text:p text:style-name="normal">
<draw:rect text:anchor-type="paragraph" draw:z-index="0" draw:style-name="cadre" draw:text-style-name="normal" svg:width="16cm" svg:height="'.($text[1]/2).'cm" svg:x="0cm" svg:y="0cm"/>
</text:p>
<text:p text:style-name="normal">' ;
}

function output_list_item_xml($text) {
	return '<text:list-item><text:p text:style="normal">'.output_translate_xml($text)."</text:p></text:list-item>\n" ;
}

function output_italique_xml($text) {
	return '<text:span text:style-name="italic">'.output_translate_xml($text)."</text:span>" ;
}

function output_cleanup_xml($text) {
	$text = preg_replace("~<text:p[^>]*>\s*</text:p>~s","",$text) ; // supprimons les paragraphes vides !
	return $text ;
}

// filtre ne faisant rien mais permettant l'criture d'un nouveau filtre :
function output_header_dummy($text) {
	return $text ;
}

function output_footer_dummy($text) {
	return $text ;
}

function output_title_dummy($text) {
	return $text ;
}

function output_start_exo_table_dummy($text) {
	return $text ;
}

function output_end_exo_table_dummy($text) {
	return $text ;
}

function output_start_exo_row_dummy($text) {
	return $text ;
}

function output_end_exo_row_dummy($text) {
	return $text ;
}

function output_start_exo_col_dummy($text) {
	return $text ;
}

function output_end_exo_col_dummy($text) {
	return $text ;
}

function output_title_section_dummy($text) {
	return $text ;
}

function output_start_unsorted_list_dummy($text) {
	return $text ;
}

function output_start_sorted_list_dummy($text) {
	return $text ;
}

function output_end_unsorted_list_dummy($text) {
	return $text ;
}

function output_end_sorted_list_dummy($text) {
	return $text ;
}

function output_math_dummy($text) {
	return $text ;
}

function output_phpgeo_dummy($text) {
	return $text ;
}

function output_cadre_dummy($text) {
	// deux paramettres: 0=>un  texte, 1=>le nombre de ligne du cadre
	return $text ;
}

function output_list_item_dummy($text) {
	return $text ;
}

function output_italique_dummy($text) {
	return $text ;
}

function output_cleanup_dummy($text) {
	return $text ;
}



?>