<?
/*
	Author		: Frederic Bonnaud, Charles Cordier
	Copyright	: 2001 Frederic Bonnaud, Charles Cordier
	EMail			: frederic.bonnaud@laposte.net, charles.cordier@laposte.net
	License		: GPL (see ../GPL)
	Warranty		: NONE, absolutly none
	Garanties	: Aucune, absolument aucune !
*/

	function get_lines($editor) {
		$editor = trim(preg_replace("~[\r\n]*~","",$editor)) ;
		preg_match_all("~(.*?)([".PONCTUATION."](?!\d))~",$editor,$matches) ;
		if (preg_match("~[^".PONCTUATION."]*$~",$editor,$match)) { //"
			$matches[0][] = $match[0] ;
			$matches[1][] = $match[0] ;
			$matches[2][] = "" ;
		}
		return $matches ;
	}

 /**********************************************************
  * On parse ***********************************************
  **********************************************************/
	// php 4 refuse de traiter correctement : $replace_str = "\\s*\\\\1\\s*" ;
	$dum = "'~&'" ; // c'est un fix !
	$replace_str  = "\\s*$dum\\1\\s*" ;
	// remplace certains caracteres spciaux (=,(,), etc.) ie : = par \s*\=\s*

	$MOTIFS[] = "~\s*([={\}])\s*~" ; $REPLACES[] = $replace_str ;
	$MOTIFS[] = "~\s*([\(\[])(?!:)\s*~" ; $REPLACES[] = $replace_str ;
	$MOTIFS[] = "~\s*(?<!:)([\)\]])\s*~" ; $REPLACES[] = $replace_str ;
	$MOTIFS[] = "/$dum/" ; $REPLACES[] = "\\" ;
	$MOTIFS[] = "~\(\:(.*?)\:\)~msi" ; $REPLACES[] = "(?:\\1)" ;
	$MOTIFS[] = "~\[\:(.*?)\:\]~msi" ; $REPLACES[] = "(\\1)" ;
	$MOTIFS[] = "~\s+~" ; $REPLACES[] = "\\s+" ;

	// remplace les %TYPE% par le pattern correspondant
	reset($TYPES) ;
	while (list($TYPE,$PATTERN) = each($TYPES)) {
		$MOTIFS[] = "~%$TYPE%~" ;
		$REPLACES[] = "($PATTERN)" ;
	}

function prepare_sentence($sentence) {
	global $TYPES,$MOTIFS,$REPLACES ;
	return preg_replace($MOTIFS,$REPLACES,$sentence) ;
} // prepare_sentence

function which_sentence($line, &$param) {
	global $SENTENCES,$ORDRECAS ;
	$param = array() ;
	reset ($ORDRECAS) ;
	while(list(,$key) = each ($ORDRECAS)) {
		if (preg_match("~^".prepare_sentence($SENTENCES[$key])."$~msi",$line,$param)) { // "
			return $key ;
		}
	}
	return 0 ;
} // which_sentence

function valide_sentence($type,&$param) {
/*
	$param est en entre : le retour de which_sentence (la numrotation doit commencer  1 (l'element 0 est ignor))
	$param contient en retour :
	 $param[<nom dans ajoute_<type>>] = <nom dans phpGo> ;

	 retourne 1 si, la phrase est valide au niveau des types des objets.
 */
	global $VALIDES,$TYPES,$ERREURSTYPE,$erreurs ;
	$old_param = $param ;
	$param = array() ;
	reset ($VALIDES[$type]) ;
	while (list($cas,$valide_param) = each($VALIDES[$type])) {
		$erreurs = array() ;
		for($i = 0 ; $i < count($valide_param) ; $i++) {
			$j = $i + 1  ; // indice dans $old_param, du au fait que preg_match renvoie le motif total dans $0.
			// il y a 2 cas particulier : UNDEF ou un nombre
			if (preg_match("/^(.*)=UNDEF$/msi",$valide_param[$i],$match)) { //"
				if (object_exists($old_param[$j])) {
					$erreurs[] = myformat(erreur_existe,array($old_param[$j])) ;
				} else {
					$param[$match[1]] = $old_param[$j] ;
				} // if
			} elseif (is_int($valide_param[$i])) { // cas ou on demande qu'un parametre soit le meme qu'un autre
//				if ($old_param[$j] != $old_param[$valide_param[$i]+1]) {
				if ($old_param[$j] != $old_param[$valide_param[$i]]) {
				// on vrifie que le $parametre courant est bien le meme que le $i me
					$erreurs[] = myformat(erreur_identique,array($old_param[$j],$old_param[$valide_param[$i]])) ;
				} // if
			} elseif (preg_match("/^(.*)=(.*)$/msi",$valide_param[$i],$match)) { //" on rcupere le nom et le type souhait
				if (preg_match("/^(.*)\[\]$/",$match[1],$nom)) { //"
				 // cas des suites de parametres (NE FONCTIONNE QU'AVEC *=TPOINT,TDROITE,TCERCLE (qui sont reprsents par des TNOMs !!!) : aucun test n'est fait !
					if (preg_match_all("~(".$TYPES[TNOM].")~", $old_param[$j], $paramlist)) {
						for($j = 0 ; $j < count($paramlist[1]) ; $j++) {
							if ($param[$nom[1]][] = & object_exists($paramlist[1][$j],$match[2])) {
							} else {
								$erreurs[] = myformat(erreur_type,array($paramlist[1][$j],$ERREURSTYPE[$match[2]])) ;
							} // if
						} // for
					} else {
						$erreurs[] = myformat(erreur_type,array($old_param[$j],$ERREURSTYPE[$match[2]."S"])) ;
					}
				} elseif ($match[2] == TMESURE) {
					$param[$match[1]] = pixel_len($old_param[$j]) ;
				} elseif ($match[2] == TANGLE) {
					$param[$match[1]] = $old_param[$j] ;
				} elseif ($match[2] == TCOULEUR) {
					$param[$match[1]] = $old_param[$j] ;
				} elseif ($match[2] == TSTYLE) {
					$param[$match[1]] = $old_param[$j] ;
				} elseif ($match[2] == TCOMMENTAIRE) {
					$param[$match[1]] = $old_param[$j] ;
				} elseif ($match[2] == TNOMBRE) {
					$param[$match[1]] = $old_param[$j] ;
				} elseif ($param[$match[1]] = & object_exists($old_param[$j],$match[2])) {
				} else {
					$erreurs[] = myformat(erreur_type,array($old_param[$j],$ERREURSTYPE[$match[2]])) ;
				}
			} else {
				echo "Unexpected error in valide_sentence, expecting type forme : 'a=TYPE'.<br>\n" ;
			} // if
		} // for
		if (count($erreurs) == 0) { // si pas d'erreur, on retourne le cas trouv
			return $cas ;
		}
	} // while
	return -1 ;
} // valide_sentence

?>
